#!/usr/bin/env python
# -*- coding: utf-8 -*-

SRV_PORT = 3030
SRV_BUFFER = 1500
SND_SRATE = 8000
SND_RECTIME = 5
SND_COUNT = -1
SND_INTERVAL = 30

from qt import *
from mainform import *
from aboutform import *
from imagec import *
import sys
import webbrowser
import thread
import socket
import signal

if sys.platform == "win32":
	import winsound

state = {
'samplerate' : SND_SRATE,
'rectime' : SND_RECTIME,
'count' : SND_COUNT,
'interval' : SND_INTERVAL,
'run' : True,
'filename' : ''
}

global sd

def connect():
	qt.maindialog.statusBar().message("Kobler til...")
	# sd = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
	
	try:
		sd.connect((str(qt.maindialog.serverEdit.text()), SRV_PORT))
	except socket.error:
		qt.maindialog.serverButton.setText("Koble til")
		qt.maindialog.filKoble_tilAction.setEnabled(True)
		qt.maindialog.filKoble_fraAction.setEnabled(False)
		qt.maindialog.serverEdit.setEnabled(True)
		qt.maindialog.statusBar().message("Kunne ikke koble til %s: %s" % (str(qt.maindialog.serverEdit.text()), sys.exc_info()[1][1]))
		sys.exit()

	qt.maindialog.settingsGroup.setEnabled(True) 
	qt.maindialog.statusBar().message("Tilkoblet %s" % str(qt.maindialog.serverEdit.text()))
	
	while state['run']:
		for line in sd.recv(SRV_BUFFER).splitlines():
			words = line.split(" ")
	
			if words[0] != "STATS" and len(words) > 1:
				print "%s - %s" % (words[0], words[1])
		
			if words[0] == "SAMPLERATE":
				state['samplerate'] = int(words[1])
				qt.maindialog.samplerateBox.setValue(state['samplerate'])
				
			elif words[0] == "RECTIME":
				state['rectime'] = int(words[1])
				qt.maindialog.lengthBox.setValue(state['rectime'])
				
			elif words[0] == "COUNT":
				state['count'] = int(words[1])
				qt.maindialog.countBox.setValue(state['count'])
				
			elif words[0] == "TRIGGER":
				if words[1] == "EXTERN":
					qt.maindialog.intervalBox.setEnabled(False)
					qt.maindialog.intervalLabel.setEnabled(False)
					qt.maindialog.externButton.setChecked(True)
				else:
					qt.maindialog.intervalBox.setEnabled(True)
					qt.maindialog.intervalLabel.setEnabled(True)
					qt.maindialog.internButton.setChecked(True)
					
			elif words[0] == "INTERVAL":
				state['interval'] = int(words[1])
				qt.maindialog.intervalBox.setValue(state['interval'])
				
			elif words[0] == "FILENAME":
				state['filename'] = words[1]
				qt.maindialog.filenamevLabel.setText(state['filename'])
				
			elif words[0] == "RECNUM":
				qt.maindialog.shotsvLabel.setText(words[1])
				
			elif words[0] == "TIMELEFT":
				if words[1] == "S":
					qt.maindialog.nextvLabel.setText("Sampler...")
					if qt.maindialog.innstillingerSpil_avl_lyd_ved_aktivering_av_triggerAction.isOn():
						winsound.Beep(1200, 500)
				elif words[1] == "-":
					qt.maindialog.nextvLabel.setText("")
				else:
					qt.maindialog.nextvLabel.setText("%s s" % words[1])

			elif words[0] == "RUNNING":
				qt.maindialog.samplerateBox.setEnabled(False)
				qt.maindialog.lengthBox.setEnabled(False)
				qt.maindialog.countBox.setEnabled(False)
				qt.maindialog.internButton.setEnabled(False)
				qt.maindialog.externButton.setEnabled(False)
				qt.maindialog.intervalBox.setEnabled(False)
				qt.maindialog.runButton.setText("Stopp")
				qt.maindialog.runButton.setEnabled(True)
			
			elif words[0] == "STOPPED":
				qt.maindialog.samplerateBox.setEnabled(True)
				qt.maindialog.lengthBox.setEnabled(True)
				qt.maindialog.countBox.setEnabled(True)
				qt.maindialog.internButton.setEnabled(True)
				qt.maindialog.externButton.setEnabled(True)
				qt.maindialog.runButton.setText("Start")
				qt.maindialog.runButton.setEnabled(True)
				if qt.maindialog.internButton.isOn():
					qt.maindialog.intervalBox.setEnabled(True)
				
			if words[0] == "STATS":
				if words[1] == "-":
					qt.maindialog.rmsvLabel.setText("")
					qt.maindialog.levelvLabel.setText("")
					qt.maindialog.ratevLabel.setText("")				
				else:
					qt.maindialog.rmsvLabel.setText("%s %%" % words[3])
					qt.maindialog.levelvLabel.setText("%s %%" % words[2])
					qt.maindialog.ratevLabel.setText("%s Hz" % words[1])

	state['run'] = False
	qt.maindialog.settingsGroup.setEnabled(False) 
	sd.close()
	qt.maindialog.statusBar().message("Frakoblet %s" % str(qt.maindialog.serverEdit.text()))
	global sd
	sd = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
	qt.maindialog.serverButton.setText("Koble til")
	qt.maindialog.filKoble_tilAction.setEnabled(True)
	qt.maindialog.filKoble_fraAction.setEnabled(False)
	qt.maindialog.serverEdit.setEnabled(True)
	
class qtgui(QApplication):
	def __init__(self, args):
		QApplication.__init__(self,args)
		
		self.connect(self, SIGNAL("lastWindowClosed()"), self, SLOT("quit()"))
		self.maindialog = mainform(None)
		
		self.setMainWidget(self.maindialog)
		
		self.maindialog.show()
	
class mainform(mainForm):
	def __init__(self,parent):
		mainForm.__init__(self,parent)
		self.aboutdialog = self.aboutform(None)
		self._connectSlots()
		self.statusBar().message("Ikke tilkoblet")
		if sys.platform == "win32":
			self.innstillingerSpil_avl_lyd_ved_aktivering_av_triggerAction.setEnabled(True)
		self.timer = QTimer(self)
		self.timer.start(500, False)
		
		
	def _connectSlots(self):
		self.connect(self.omOmAction, SIGNAL("activated()"), self._slotOmActivated)
		self.connect(self.hjelpInternettFagprveAction, SIGNAL("activated()"), self._slotInternettFagprveActivated)
		self.connect(self.hjelpInternettElabAction, SIGNAL("activated()"), self._slotInternettElabActivated)
		self.connect(self.filKoble_tilAction, SIGNAL("activated()"), self._slotServerButtonClicked)
		self.connect(self.filKoble_fraAction, SIGNAL("activated()"), self._slotServerButtonClicked)
		self.connect(self.serverButton, SIGNAL("clicked()"), self._slotServerButtonClicked)
		self.connect(self.samplerateBox, SIGNAL("valueChanged(int)"), self._slotSamplerateBoxChanged)
		self.connect(self.lengthBox, SIGNAL("valueChanged(int)"), self._slotLengthBoxChanged)
		self.connect(self.countBox, SIGNAL("valueChanged(int)"), self._slotCountBoxChanged)
		self.connect(self.intervalBox, SIGNAL("valueChanged(int)"), self._slotIntervalBoxChanged)
		self.connect(self.externButton, SIGNAL("clicked()"), self._slotExternButtonClicked)
		self.connect(self.internButton, SIGNAL("clicked()"), self._slotInternButtonClicked)
		self.connect(self.runButton, SIGNAL("clicked()"), self._slotRunButtonClicked)

	def _slotOmActivated(self):
		self.aboutdialog.show()
		
	def _slotInternettFagprveActivated(self):
		webbrowser.open("http://www2.geo.uib.no/service-elektronikk/fagprover/JanInge/")
		
	def _slotInternettElabActivated(self):
		webbrowser.open("http://www2.geo.uib.no/")
		
	def _slotServerButtonClicked(self):
		if self.serverButton.text() == "Koble til":
			self.serverButton.setText("Koble fra")
			self.serverEdit.setEnabled(False)
			self.filKoble_tilAction.setEnabled(False)
			self.filKoble_fraAction.setEnabled(True)
			state['run'] = True
			thread.start_new_thread(connect, ())
		else:
			state['run'] = False
			self.serverButton.setText("Koble til")
			self.serverEdit.setEnabled(True)
			self.filKoble_tilAction.setEnabled(True)
			self.filKoble_fraAction.setEnabled(False)
			
	def _slotRunButtonClicked(self):
		if self.runButton.text() == "Start":
			self.samplerateBox.setEnabled(False)
			self.lengthBox.setEnabled(False)
			self.countBox.setEnabled(False)
			self.internButton.setEnabled(False)
			self.externButton.setEnabled(False)
			self.intervalBox.setEnabled(False)
			self.runButton.setEnabled(False)
			self.runButton.setText("Stopp")
			sd.send("RUN")
			
		else:
			self.runButton.setEnabled(False)
			sd.send("STOP")
	
	def _slotSamplerateBoxChanged(self):
		nrate = int(str(self.samplerateBox.cleanText()))
		if nrate != state['samplerate']:
			sd.send("SAMPLERATE %i\n" % nrate)
			state['samplerate'] = nrate
	
	def _slotLengthBoxChanged(self):
		ntime = int(str(self.lengthBox.cleanText()))
		if ntime != state['rectime']:
			sd.send("RECTIME %i\n" % ntime)
			state['rectime'] = ntime
			
	def _slotCountBoxChanged(self):
		try:
			ncount = int(str(self.countBox.cleanText()))
		except:
			ncount = -1
		if ncount != state['count']:
			sd.send("COUNT %i\n" % ncount)
			state['count'] = ncount
			
	def _slotIntervalBoxChanged(self):
		ninterval = int(str(self.intervalBox.cleanText()))
		if ninterval != state['interval']:
			sd.send("INTERVAL %i\n" % ninterval)
			state['interval'] = ninterval
	
	def _slotExternButtonClicked(self):
		self.intervalBox.setEnabled(False)
		self.intervalLabel.setEnabled(False)
		sd.send("TRIGGER EXTERN")
		
	def _slotInternButtonClicked(self):
		self.intervalBox.setEnabled(True)
		self.intervalLabel.setEnabled(True)
		sd.send("TRIGGER INTERN")
		
	class aboutform(aboutForm):
		def __init__(self,modal=1):
			aboutForm.__init__(self,modal)

if __name__ == "__main__":
	sd = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
	qt = qtgui(sys.argv)
	qt.exec_loop()
	state['run'] = not state['run']
